//%attributes = {}
// ==========================================
// Load configs

C_TEXT:C284($configsPath)
$configsPath:=Get 4D folder:C485(Current resources folder:K5:16)+"GridConfigs.json"

C_TEXT:C284($configsText)
$configsText:=Document to text:C1236($configsPath)

ARRAY OBJECT:C1221(gGridConfigs; 0)
JSON PARSE ARRAY:C1219($configsText; gGridConfigs)

ARRAY TEXT:C222($configNames; Size of array:C274(gGridConfigs))

C_LONGINT:C283($ii)

For ($ii; 1; Size of array:C274(gGridConfigs))
	
	C_OBJECT:C1216($aConfig)
	$aConfig:=gGridConfigs{$ii}
	
	C_TEXT:C284($aConfigName)
	$aConfigName:=OB Get:C1224($aConfig; "name"; Is text:K8:3)
	
	$configNames{$ii}:=$aConfigName
	
End for 

C_POINTER:C301($configsObj)
$configsObj:=OBJECT Get pointer:C1124(Object named:K67:5; "cell-configs")

COPY ARRAY:C226($configNames; $configsObj->)

// ==========================================
// Load fonts

ARRAY TEXT:C222($fontList; 0)
FONT LIST:C460($fontList)

C_POINTER:C301($fontObj)
$fontObj:=OBJECT Get pointer:C1124(Object named:K67:5; "text-font")

COPY ARRAY:C226($fontList; $fontObj->)


// ==========================================
// Set defaults

OBJ_SET_LONG("num-cells"; 100)
OBJ_SET_LONG("cells-in-band"; 0)

$configsObj->:=1

OBJ_SELECT_LIST_ITEM_BY_REF("horz-alignment"; qg_AlignHorzCenter)
OBJ_SELECT_LIST_ITEM_BY_REF("vert-alignment"; qg_AlignVertTop)

OBJ_SET_LONG("cell-spacing-x"; 0)
OBJ_SET_LONG("cell-spacing-y"; 0)

OBJ_SET_LONG("cell-scroll"; 0)
OBJ_SET_LONG("display-tooltips"; 0)

OBJ_SELECT_LIST_ITEM_BY_REF("selection-options"; qg_SelectOneCell)

OBJ_SET_BACK_COLOR("back-color"; 0x00FFFFFF)

OBJ_SELECT_LIST_ITEM_BY_REF("pict-display-format"; qg_PictScaledToFitPropCenter)

If (<>gIsWindows)
	$fontObj->:=Find in array:C230($fontObj->; "Segoe UI")
Else 
	$fontObj->:=Find in array:C230($fontObj->; "Lucida Grande")
End if 

OBJ_SET_LONG("text-size"; 10)

OBJ_SET_LONG("text-style-b"; 0)
OBJ_SET_LONG("text-style-i"; 0)

//OBJ_SELECT_LIST_ITEM_BY_REF ("text-alignment";qg_JustLeft)
OBJ_SELECT_LIST_ITEM_BY_REF("text-horz-alignment"; qg_AlignHorzLeft)
OBJ_SELECT_LIST_ITEM_BY_REF("text-vert-alignment"; qg_AlignVertTop)

OBJ_SET_BACK_COLOR("text-color"; 0x0000)

C_BOOLEAN:C305($draggable; $automaticDrag; $droppable; $automaticDrop)
OBJECT GET DRAG AND DROP OPTIONS:C1184(xGrid; $draggable; $automaticDrag; $droppable; $automaticDrop)

OBJ_SET_LONG("dnd-draggable"; Num:C11($draggable))
OBJ_SET_LONG("dnd-droppable"; Num:C11($droppable))

OBJ_SET_LONG("drag-fb-caret-width"; 2)
OBJ_SET_BACK_COLOR("drag-fb-color"; 0x00FF0000)
OBJ_SET_LONG("drag-fb-deco-caret"; 1)
OBJ_SET_LONG("drag-fb-blinking-caret"; 1)
OBJ_SET_LONG("drag-fb-blink-interval"; 30)
OBJECT SET ENTERABLE:C238(*; "drag-fb-blink-interval"; True:C214)
