//%attributes = {}
C_TEXT:C284($1; $what)

If (Count parameters:C259>0)
	$what:=$1
Else 
	$what:=""
End if 

C_LONGINT:C283($err)

If (($what="config") | ($what=""))
	
	// General config
	
	C_POINTER:C301($configsObjPtr)
	$configsObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "cell-configs")
	
	C_LONGINT:C283($configIdx)
	$configIdx:=$configsObjPtr->
	
	C_OBJECT:C1216($configObj)
	$configObj:=gGridConfigs{$configIdx}
	
	C_LONGINT:C283($cellWidth; $cellHeight)
	$cellWidth:=-1
	$cellHeight:=-1
	
	If (OB Is defined:C1231($configObj; "width") & OB Is defined:C1231($configObj; "height"))
		$cellWidth:=OB Get:C1224($configObj; "width"; Is integer:K8:5)
		$cellHeight:=OB Get:C1224($configObj; "height"; Is integer:K8:5)
	End if 
	
	C_PICTURE:C286($cellPict)
	If (OB Is defined:C1231($configObj; "image"))
		C_TEXT:C284($imageFileName; $imagePath)
		$imageFileName:=OB Get:C1224($configObj; "image"; Is text:K8:3)
		$imagePath:=Get 4D folder:C485(Current resources folder:K5:16)+"Cells"+Folder separator:K24:12+$imageFileName
		ASSERT:C1129(Test path name:C476($imagePath)=Is a document:K24:1)
		
		If ($imagePath="@.svg")
			C_TEXT:C284($svg)
			$svg:=DOM Parse XML source:C719($imagePath)
			ASSERT:C1129(OK=1)
			SVG EXPORT TO PICTURE:C1017($svg; $cellPict)
			ASSERT:C1129(OK=1)
			DOM CLOSE XML:C722($svg)
		Else 
			READ PICTURE FILE:C678($imagePath; $cellPict)
			ASSERT:C1129(OK=1)
		End if 
		
	End if 
	
	C_LONGINT:C283($xRadius; $yRadius)
	$xRadius:=0
	$yRadius:=0
	
	If (OB Is defined:C1231($configObj; "x-radius") & OB Is defined:C1231($configObj; "y-radius"))
		$xRadius:=OB Get:C1224($configObj; "x-radius"; Is integer:K8:5)
		$yRadius:=OB Get:C1224($configObj; "y-radius"; Is integer:K8:5)
	End if 
	
	C_LONGINT:C283($xSpacing; $ySpacing)
	$xSpacing:=0
	$ySpacing:=0
	
	If (OB Is defined:C1231($configObj; "x-spacing") & OB Is defined:C1231($configObj; "y-spacing"))
		$xSpacing:=OB Get:C1224($configObj; "x-spacing"; Is integer:K8:5)
		$ySpacing:=OB Get:C1224($configObj; "y-spacing"; Is integer:K8:5)
	End if 
	
	C_OBJECT:C1216($pictObj; $pictBoundsObj)
	$pictObj:=OB Get:C1224($configObj; "picture")
	$pictBoundsObj:=OB Get:C1224($pictObj; "bounds")
	
	C_LONGINT:C283($pictLeft; $pictTop; $pictRight; $pictBottom)
	$pictLeft:=OB Get:C1224($pictBoundsObj; "left"; Is longint:K8:6)
	$pictTop:=OB Get:C1224($pictBoundsObj; "top"; Is longint:K8:6)
	$pictRight:=OB Get:C1224($pictBoundsObj; "right"; Is longint:K8:6)
	$pictBottom:=OB Get:C1224($pictBoundsObj; "bottom"; Is longint:K8:6)
	
	C_LONGINT:C283($pictDisplayFormat)
	$pictDisplayFormat:=qg_PictScaledToFitPropCenter
	If (OB Is defined:C1231($pictObj; "display"))
		$pictDisplayFormat:=OB Get:C1224($pictObj; "display"; Is integer:K8:5)
	End if 
	
	C_OBJECT:C1216($captionObj; $captionBoundsObj)
	$captionObj:=OB Get:C1224($configObj; "caption")
	$captionBoundsObj:=OB Get:C1224($captionObj; "bounds")
	
	C_LONGINT:C283($captionLeft; $captionTop; $captionRight; $captionBottom)
	$captionLeft:=OB Get:C1224($captionBoundsObj; "left"; Is longint:K8:6)
	$captionTop:=OB Get:C1224($captionBoundsObj; "top"; Is longint:K8:6)
	$captionRight:=OB Get:C1224($captionBoundsObj; "right"; Is longint:K8:6)
	$captionBottom:=OB Get:C1224($captionBoundsObj; "bottom"; Is longint:K8:6)
	
	C_TEXT:C284($platformSuffix)
	If (<>gIsWindows)
		$platformSuffix:="win"
	Else 
		$platformSuffix:="mac"
	End if 
	
	C_TEXT:C284($captionTextFont)
	If (OB Get type:C1230($captionObj; "text-font-"+$platformSuffix)#Is undefined:K8:13)
		$captionTextFont:=OB Get:C1224($captionObj; "text-font-"+$platformSuffix; Is text:K8:3)
	Else 
		$captionTextFont:=OB Get:C1224($captionObj; "text-font"; Is text:K8:3)
	End if 
	
	C_LONGINT:C283($captionTextSize)
	If (OB Get type:C1230($captionObj; "text-size-"+$platformSuffix)#Is undefined:K8:13)
		$captionTextSize:=OB Get:C1224($captionObj; "text-size-"+$platformSuffix; Is longint:K8:6)
	Else 
		$captionTextSize:=OB Get:C1224($captionObj; "text-size"; Is longint:K8:6)
	End if 
	
	C_LONGINT:C283($captionHorzAlign)
	$captionHorzAlign:=qg_AlignHorzLeft
	If (OB Get type:C1230($captionObj; "horz-align")#Is undefined:K8:13)
		C_TEXT:C284(alignAttr)
		alignAttr:=OB Get:C1224($captionObj; "horz-align"; Is text:K8:3)
		Case of 
			: (alignAttr="left")
				$captionHorzAlign:=qg_AlignHorzLeft
			: (alignAttr="center")
				$captionHorzAlign:=qg_AlignHorzCenter
			: (alignAttr="right")
				$captionHorzAlign:=qg_AlignHorzRight
		End case 
	End if 
	
	C_LONGINT:C283($captionVertAlign)
	$captionVertAlign:=qg_AlignVertTop
	If (OB Get type:C1230($captionObj; "vert-align")#Is undefined:K8:13)
		C_TEXT:C284(alignAttr)
		alignAttr:=OB Get:C1224($captionObj; "vert-align"; Is text:K8:3)
		Case of 
			: (alignAttr="top")
				$captionVertAlign:=qg_AlignVertTop
			: (alignAttr="center")
				$captionVertAlign:=qg_AlignVertCenter
			: (alignAttr="bottom")
				$captionVertAlign:=qg_AlignVertBottom
		End case 
	End if 
	
	C_OBJECT:C1216($captionTextColorObj)
	$captionTextColorObj:=OB Get:C1224($captionObj; "text-color")
	
	C_LONGINT:C283($captionTextColorR; $captionTextColorG; $captionTextColorB)
	$captionTextColorR:=OB Get:C1224($captionTextColorObj; "r"; Is longint:K8:6)
	$captionTextColorG:=OB Get:C1224($captionTextColorObj; "g"; Is longint:K8:6)
	$captionTextColorB:=OB Get:C1224($captionTextColorObj; "b"; Is longint:K8:6)
	
	C_LONGINT:C283($captionTextColor)
	$captionTextColor:=($captionTextColorR << 16) | ($captionTextColorG << 8) | $captionTextColorB
	
	C_LONGINT:C283($selectionWidth; $selectionColor)
	$selectionWidth:=2
	$selectionColor:=0x00FF0000
	
	If (OB Is defined:C1231($configObj; "selection"))
		
		C_OBJECT:C1216($selectionObj)
		$selectionObj:=OB Get:C1224($configObj; "selection")
		
		If (OB Is defined:C1231($selectionObj; "width"))
			$selectionWidth:=OB Get:C1224($selectionObj; "width"; Is longint:K8:6)
		End if 
		If (OB Is defined:C1231($selectionObj; "color"))
			
			C_OBJECT:C1216($selectionColorObj)
			$selectionColorObj:=OB Get:C1224($selectionObj; "color")
			
			C_LONGINT:C283($selectionColorR; $selectionColorG; $selectionColorB)
			$selectionColorR:=OB Get:C1224($selectionColorObj; "r"; Is longint:K8:6)
			$selectionColorG:=OB Get:C1224($selectionColorObj; "g"; Is longint:K8:6)
			$selectionColorB:=OB Get:C1224($selectionColorObj; "b"; Is longint:K8:6)
			
			$selectionColor:=($selectionColorR << 16) | ($selectionColorG << 8) | $selectionColorB
			
		End if 
	End if 
	
	// Area setup
	
	$err:=QG_SetEventHandler:P11567:71(xGrid; "LAB_CB_Event"; qg_TrapClickEvent | qg_TrapDoubleClickEvent)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetNumCells:P11567:12(xGrid; "0")
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCellOptions:P11567:6(xGrid; $cellWidth; $cellHeight; $cellPict; qg_PictScaledToFit; $xRadius; $yRadius)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCellSpacing:P11567:40(xGrid; $xSpacing; $ySpacing)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCellPicture:P11567:20(xGrid; "LAB_X_Picture(gQGCurrentCell)"; $pictLeft; $pictTop; $pictRight; $pictBottom; $pictDisplayFormat)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCellCaption:P11567:22(xGrid; "LAB_X_Caption(gQGCurrentCell)"; $captionLeft; $captionTop; $captionRight; $captionBottom; "")
	ASSERT:C1129($err=qg_noErr)
	
	C_LONGINT:C283($selectionFlags)
	$err:=QG_GetSelectionOptions:P11567:9(xGrid; $selectionFlags)
	ASSERT:C1129($err=qg_noErr)
	$err:=QG_SetSelectionOptions:P11567:8(xGrid; $selectionFlags; $selectionColor; $selectionWidth)
	ASSERT:C1129($err=qg_noErr)
	
	OBJ_SET_LONG("cell-spacing-x"; $xSpacing)
	OBJ_SET_LONG("cell-spacing-y"; $ySpacing)
	
	OBJ_SELECT_LIST_ITEM_BY_REF("pict-display-format"; $pictDisplayFormat)
	
	C_POINTER:C301($fontObjPtr)
	$fontObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "text-font")
	C_LONGINT:C283($fontIdx)
	$fontIdx:=Find in array:C230($fontObjPtr->; $captionTextFont)
	$fontObjPtr->:=$fontIdx
	
	OBJ_SET_LONG("text-size"; $captionTextSize)
	OBJ_SET_BACK_COLOR("text-color"; $captionTextColor)
	
	OBJ_SELECT_LIST_ITEM_BY_REF("text-horz-alignment"; $captionHorzAlign)
	OBJ_SELECT_LIST_ITEM_BY_REF("text-vert-alignment"; $captionVertAlign)
	
	If ($what="config")  // If this is an explicit call, no full setup
		
		LAB_SETUP_GRID("cell-caption")  // We have changed text size & color
		
		LAB_SETUP_GRID("num-cells")  // Reset number of cells
		
	End if 
	
End if 

If (($what="grid-alignment") | ($what=""))
	
	// Alignment
	
	C_LONGINT:C283($horzAlignment; $vertAlignment)
	$horzAlignment:=OBJ_Get_Selected_List_Item_Ref("horz-alignment")
	$vertAlignment:=OBJ_Get_Selected_List_Item_Ref("vert-alignment")
	
	$err:=QG_SetAreaAlignment:P11567:35(xGrid; $horzAlignment; $vertAlignment)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="cell-spacing") | ($what=""))
	
	C_LONGINT:C283($xSpacing; $ySpacing)
	$xSpacing:=OBJ_Get_Long("cell-spacing-x")
	$ySpacing:=OBJ_Get_Long("cell-spacing-y")
	$err:=QG_SetCellSpacing:P11567:40(xGrid; $xSpacing; $ySpacing)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="grid-flags") | ($what=""))
	
	// Flags
	
	C_BOOLEAN:C305($cellScroll; $displayTooltips)
	$cellScroll:=OBJ_Get_Boolean("cell-scroll")
	$displayTooltips:=OBJ_Get_Boolean("display-tooltips")
	
	C_LONGINT:C283($areaFlags)
	$areaFlags:=0
	If ($cellScroll)
		$areaFlags:=$areaFlags | qg_CellScrollMask
	End if 
	If ($displayTooltips)
		$areaFlags:=$areaFlags | qg_TooltipsEnabledMask
	End if 
	
	$err:=QG_SetAreaFlags:P11567:4(xGrid; $areaFlags)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="grid-selection") | ($what=""))
	
	// Selection
	
	C_LONGINT:C283($selectionFlags)
	$selectionFlags:=OBJ_Get_Selected_List_Item_Ref("selection-options")
	
	C_LONGINT:C283($oldSelectionFlags; $frameColor; $frameSize)
	$err:=QG_GetSelectionOptions:P11567:9(xGrid; $oldSelectionFlags; $frameColor; $frameSize)
	ASSERT:C1129($err=qg_noErr)
	$err:=QG_SetSelectionOptions:P11567:8(xGrid; $selectionFlags; $frameColor; $frameSize)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="grid-back-color") | ($what=""))
	
	// Back color
	
	C_LONGINT:C283($backColor)
	$backColor:=OBJ_Get_Back_Color("back-color")
	
	$err:=QG_SetAreaBackgroundColor:P11567:51(xGrid; $backColor)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="cell-picture") | ($what=""))
	
	// Cell pict
	
	C_LONGINT:C283($pictDisplayFormat)
	$pictDisplayFormat:=OBJ_Get_Selected_List_Item_Ref("pict-display-format")
	
	C_TEXT:C284($pictExpression)
	C_LONGINT:C283($pictLeft; $pictTop; $pictRight; $pictBottom)
	C_LONGINT:C283($oldPictDisplayFormat)
	
	$err:=QG_GetCellPicture:P11567:21(xGrid; $pictExpression; $pictLeft; $pictTop; $pictRight; $pictBottom; $oldPictDisplayFormat)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCellPicture:P11567:20(xGrid; $pictExpression; $pictLeft; $pictTop; $pictRight; $pictBottom; $pictDisplayFormat)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="cell-caption") | ($what=""))
	
	// Cell caption
	
	C_POINTER:C301($fontObjPtr)
	$fontObjPtr:=OBJECT Get pointer:C1124(Object named:K67:5; "text-font")
	
	C_TEXT:C284($fontName)
	$fontName:=$fontObjPtr->{$fontObjPtr->}
	
	C_LONGINT:C283($textSize)
	$textSize:=OBJ_Get_Long("text-size")
	
	C_BOOLEAN:C305($bold; $italic)
	$bold:=OBJ_Get_Boolean("text-style-b")
	$italic:=OBJ_Get_Boolean("text-style-i")
	
	C_LONGINT:C283($textFace)
	$textFace:=0
	If ($bold)
		$textFace:=$textFace | Bold:K14:2
	End if 
	If ($italic)
		$textFace:=$textFace | Italic:K14:3
	End if 
	
	//C_LONGINT($textAlignment)
	//$textAlignment:=OBJ_Get_Selected_List_Item_Ref ("text-alignment")
	
	C_LONGINT:C283($textHorzAlignment; $textVertAlignment)
	$textHorzAlignment:=OBJ_Get_Selected_List_Item_Ref("text-horz-alignment")
	$textVertAlignment:=OBJ_Get_Selected_List_Item_Ref("text-vert-alignment")
	
	C_LONGINT:C283($textColor)
	$textColor:=OBJ_Get_Back_Color("text-color")
	
	$err:=QG_SetCaptionFont:P11567:25(xGrid; $fontName; $textSize; $textFace)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCaptionColors:P11567:27(xGrid; $textColor; qg_NoFillColor)
	ASSERT:C1129($err=qg_noErr)
	
	$err:=QG_SetCaptionAlignment:P11567:29(xGrid; $textHorzAlignment; $textVertAlignment)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="num-cells") | ($what=""))
	
	C_LONGINT:C283($numCells)
	$numCells:=OBJ_Get_Long("num-cells")
	
	// Prepare data
	
	ARRAY LONGINT:C221(gCellData; $numCells; 2)
	For ($ii; 1; $numCells)
		
		gCellData{$ii}{1}:=(Random:C100%Size of array:C274(<>gPictures))+1
		gCellData{$ii}{2}:=(Random:C100%Size of array:C274(<>gCaptions))+1
		
	End for 
	
	$err:=QG_SetNumCells:P11567:12(xGrid; String:C10($numCells))
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="cells-in-band") | ($what=""))
	
	C_LONGINT:C283($cellsInBand)
	$cellsInBand:=OBJ_Get_Long("cells-in-band")
	
	$err:=QG_SetCellsPerRow:P11567:10(xGrid; $cellsInBand)
	ASSERT:C1129($err=qg_noErr)
	
End if 

If (($what="drag-and-drop") | ($what=""))
	
	C_LONGINT:C283($options; $width; $color; $interval)
	
	$options:=0
	If (OBJ_Get_Long("drag-fb-deco-caret")=1)
		$options:=$options | qg_UseDecoratedCaret
	End if 
	If (OBJ_Get_Long("drag-fb-blinking-caret")=1)
		$options:=$options | qg_UseBlinkingCaret
	End if 
	
	$width:=OBJ_Get_Long("drag-fb-caret-width")
	$color:=OBJ_Get_Back_Color("drag-fb-color")
	$interval:=OBJ_Get_Long("drag-fb-blink-interval")
	
	$err:=QG_SetDragOptions:P11567:78(xGrid; $options; $width; $color; $interval)
	ASSERT:C1129($err=qg_noErr)
	
End if 

